import React, {useState} from "react"

export default class LoginForm extends React.Component 
{
    constructor() 
    {
        super()

        this.state = 
        {
            email: "",
            password: "",
            wasSubmittedAtLeastOnce: false
        }
    }


    handleEmailChange = e => 
    {
        this.setState({email: e.target.value})
    }


    handlePasswordChange = e => 
    {
        this.setState({password: e.target.value})
    }


    handleSubmit = e => 
    {        
        this.setState({wasSubmittedAtLeastOnce: true})
        const formInputsState = this.validate()
    
        if (Object.keys(formInputsState).every(index => formInputsState[index])) 
        {
            alert(`Registered details to be submitted are...    email: ${this.state.email} password: ${this.state.password}`)
        }
        else // invalid inputs in form
        {
            e.preventDefault()
            return    
        }
    }


    validateEmail()
    {    
        // valid email pattern
        const pattern = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
        return pattern.test(String(this.state.email).toLowerCase())
    }


    validatePassword()
    {    
        const pattern = /^(?=.*[0-9])(?=.*[a-z])(?=.*[A-Z])(?=.*[£!#€$%^&*]).{10,}$/
        return pattern.test(String(this.state.password)) 
    }


    validate() 
    {
        return {
            email: this.validateEmail(),
            password: this.validatePassword()
        }
    }


    render() 
    {
        let errorMessage = ""
        if(this.state.wasSubmittedAtLeastOnce)
        {
            errorMessage = <div className="error">Login Details are incorrect<br/></div>
        }
         
        return (          
          <form noValidate = {true} id = "loginForm" onSubmit = {this.handleSubmit}>
            {errorMessage}
            
            <input  
                name = "email"              
                type = "email"
                placeholder = "Email"
                value = {this.state.email}
                onChange = {this.handleEmailChange}
            />
            
               
            <input   
              name = "password"          
              type = "password"
              placeholder = "Password"
              value = {this.state.password}
              onChange = {this.handlePasswordChange}
            />

                                    
            <input 
              type = "submit" 
              value = "Login" 
            />
          </form>
        )
    }
}